import string
import sys

# ------------------------------------------------------------------------------
def replace(lwsFile):
# ------------------------------------------------------------------------------
    """
    Open <lwsFile> and replace all occurences of .lwo by .obj
    """
    
    file = open(lwsFile, "r")
    code = file.read()
    file.close()
    
    code = string.replace(code, ".lwo", ".obj")
    
    file = open(lwsFile, "w")
    file.write(code)
    file.close()

# ------------------------------------------------------------------------------
def addMtlLib(objFile, mtlLib):
# ------------------------------------------------------------------------------
    """
    Add "mtllib" statement to <objFile> if necessary
    """
    
    file = open(objFile, "r")
    code = file.read()
    file.close()
    
    # If no "mtllib" statement was found then ad it
    found = code.find("mtllib")
    if found == -1:
        code = "mtllib "+mtlLib+"\n"+code
        
    file = open(objFile, "w")
    file.write(code)
    file.close()
    
# ------------------------------------------------------------------------------
def fix(lwsFile):
# ------------------------------------------------------------------------------
    """
    Go through all .obj files in <lwsFile> and call addMtlLib()
    """
    
    file = open(lwsFile, "r")
    code = file.read()
    file.close()
    
    mtlLib = string.replace(lwsFile, ".lws", ".mtl")
    
    curPos = string.find(code, ".obj")
    done = []
    # Add "mtllib" to all .obj files if necessary
    while curPos != -1:
        slash = string.rfind(code, "/", 0, curPos)
        objFile = code[slash+1:curPos+4]
        
        if not objFile in done:
            done.append(objFile)
            addMtlLib(objFile, mtlLib)
            
        curPos = string.find(code, ".obj", curPos+4)
        
   
# ------------------------------------------------------------------------------
def main():
# ------------------------------------------------------------------------------
    usageMsg = """\
    
    Usage: objFix.py lightwaveFile.lws
    """
    if len(sys.argv) <= 1:
        print usageMsg
        sys.exit(1)
    
    replace(sys.argv[1])
    fix(sys.argv[1])

main()   
    